package
{
	import com.google.analytics.debug._Style;
	import com.greensock.TweenLite;
	import com.greensock.TweenMax;
	import com.greensock.plugins.HexColorsPlugin;
	import com.greensock.plugins.TweenPlugin;
	
	import org.flixel.*;
	import org.flixel.system.*;
	
	public class Epilogue extends FlxState
	{
		
		[Embed(source = "data/endingbg1.png")] public static var ImgBg1:Class;
		[Embed(source = "data/endingbg2.png")] public static var ImgBg2:Class;
		[Embed(source = "data/endingbg3.png")] public static var ImgBg3:Class;
		
		private var _text1:FlxText;
		private var _text2:FlxText;
		private var _text3:FlxText;
		private var _endtext:FlxText;
		
		private var bg1:FlxSprite;
		private var bg2:FlxSprite;
		private var bg3:FlxSprite;
		
		public static var save:FlxSave;
		private var fading:Boolean=false;
		override public function create():void
		{						
			FlxG.playMusic(GameState.SndSadMusic,1.0);
			
			bg1 = new FlxSprite(0,0,ImgBg1);
			bg2 = new FlxSprite(0,0,ImgBg2);
			bg3 = new FlxSprite(0,0,ImgBg3);
			
			add(bg1);
			add(bg2);
			add(bg3);
			bg1.alpha=1;
			bg2.alpha=0;
			bg3.alpha=0;		
			
			
			
			_text1 = new FlxText(5,14,FlxG.width-6,"AAA");			
			_text1.color=0xffffff;
			_text1.visible=false;
			add(_text1);
			_text2 = new FlxText(5,125,FlxG.width-6,"BBB");			
			_text2.color=0xffffff;
			_text2.alignment="right";
			_text2.visible=false;
			add(_text2);
			_text3 = new FlxText(1,123,FlxG.width-6,"CCC");			
			_text3.color=0xffffff;
			_text3.visible=false;
			add(_text3);
			
			_endtext = new FlxText(0,126,FlxG.width,"The End");
			_endtext.size=16;
			_endtext.alignment="center";
			_endtext.alpha=0;
			add(_endtext);
			SetStage();
		}
			
		private var stage:int=0;
		
		private function SetStage():void
		{
			_text1.visible=true;
			_text2.visible=true;
			_text3.visible=true;
			TweenMax.killAll(true);
			_text1.alpha=0;
			_text2.alpha=0;
			_text3.alpha=0;
			
			switch(stage)
			{
				case 0:
					TweenLite.to(_text1,textfadein*3,{alpha:1});
					_text1.text="Guess we have everything packed now.";
					break;
				case 1:
					TweenLite.to(_text2,textfadein,{alpha:1});
					_text2.text="Yeah.";
					break;
				case 2:
					TweenLite.to(_text2,textfadein,{alpha:1});
					_text2.text="It'll be strange not living here any more.";
					break;
				case 3:
					TweenLite.to(_text1,textfadein,{alpha:1});
					_text1.text="We're moving to America - it's going to be awesome!";
					break;
				case 4:
					TweenLite.to(_text2,textfadein,{alpha:1});
					_text2.text="Yeah : )";
					break;
				case 5:
					TweenLite.to(_text1,textfadein,{alpha:1});
					_text1.text="Only one thing left to do...";
					break;
				case 6:
					TweenLite.to(_text2,textfadein,{alpha:1});
					_text2.text="Yeah";
					break;
				case 7:
					TweenLite.to(_text1,textfadein,{alpha:1});
					_text1.text="I wish we could have taken him with us...";
					break;
				case 8:					
					TweenLite.to(bg1,1.0,{alpha:0});
					TweenLite.to(bg2,4.0,{alpha:1,delay:1});
					TweenLite.to(_text3,4.0,{alpha:1,delay:1});
					_text3.text="I'll miss you so much, Jack";
					break;
				case 9:
					TweenLite.to(_text3,textfadein,{alpha:1});
					_text3.text="I'm sure they'll find you a good home,";
					break;
				case 10:
					TweenLite.to(_text3,textfadein,{alpha:1});
					_text3.text="some good owners to love you :)";
					break;
				case 11:
					TweenLite.to(_text3,textfadein,{alpha:1});
					_text3.text="There's a good boy, Jack!";
					break;
				case 12:
					TweenLite.to(_text3,textfadein,{alpha:1});
					_text3.text="Bye bye";
					break;
				case 13:
					TweenLite.to(bg3,0.25,{alpha:1});
					TweenLite.to(_endtext,4,{alpha:1,delay:0.5});
					break;
				case 14:
					_endtext.alpha=1;
					FadeOut();
					break;
			}
		}
		
		private var textfadein:Number=0.4;
		
		private function FadeOut():void
		{			
				if (fading)
					return;
				
				FlxG.play(GameState.SndClick);
				FlxG.music.fadeOut(5);
				fading=true;
				FlxG.fade(0xff000000,5,function():void{FlxG.switchState(new TitleState());});
		
		}
		override public function update():void
		{
			if (fading)
				return;
			
			if (FlxG.mouse.justPressed())
			{
				stage++;
				SetStage();
			}
		}

	}
}